import { Action } from '@ngrx/store';

import { RPCError } from 'packages/core/rpc/error';

import { Infra } from '../../model';
import { Page } from '../../../../app/commons/model';

export enum ActionType {
    Readbydomain = '[infra.readbydomain] Readbydomain',
    ReadbydomainSuccess = '[infra.readbydomain] ReadbydomainSuccess',
    ReadbydomainFailure = '[infra.readbydomain] ReadbydomainFailure',
}

export class Readbydomain implements Action {
  readonly type = ActionType.Readbydomain;

  constructor(public payload: Infra) {}
}

export class ReadbydomainSuccess implements Action {
  readonly type = ActionType.ReadbydomainSuccess;

  constructor(public payload: Page) {}
}

export class ReadbydomainFailure implements Action {
  readonly type = ActionType.ReadbydomainFailure;

  constructor(public payload: RPCError) {}
}

export type Actions =
  | Readbydomain
  | ReadbydomainSuccess
  | ReadbydomainFailure
;
