import {
    createSelector,
    createFeatureSelector,
    ActionReducerMap,
  } from '@ngrx/store';

  import { StateSelector } from 'packages/commons/util/ngrx/store';

  import { MODULE } from '../notification.constant';

  import * as ReadAllByMemberStore from './readallbymember';

  export interface State {
    readallbymember: ReadAllByMemberStore.State;
  }

  export const REDUCERS = {
    readallbymember: ReadAllByMemberStore.reducer,
  };

  export const EFFECTS = [
    ReadAllByMemberStore.Effects,
  ];

  export const selectNotificationState = createFeatureSelector<State>(MODULE.name);

  export const ReadAllByMemberSelector = new StateSelector<ReadAllByMemberStore.State>(createSelector(
    selectNotificationState,
    (state: State) => state.readallbymember
  ));
