import {
    Actions,
    ActionType,
  } from './readallbymember.action';

  import {
    State,
    initialState,
  } from './readallbymember.state';

  import { Notification } from '../../model';

  export function reducer(state = initialState, action: Actions): State {
    switch (action.type) {
      case ActionType.ReadAllByMember: {
        return {
          ...state,
          error: null,
          pending: true,
        };
      }

      case ActionType.ReadAllByMemberSuccess: {
        return {
          ...state,
          error: null,
          pending: false,
          notificationList: action.payload,
        };
      }

      case ActionType.ReadAllByMemberFailure: {
        return {
          ...state,
          error: action.payload,
          pending: false,
          notificationList: null,
        };
      }

      default: {
        return state;
      }
    }
  }
